#include "RB_BSTree.h"
#include "BSTree.h"

#include <iostream>
#include <ctime>
#include <cmath>

int main()
{
   RBTree tree;
   std::cout << tree.find(10) << "\n";
   std::cout << tree.empty() << "\n";
   tree.print(std::cout); 
   tree.insert(10);
   tree.print(std::cout); 
   tree.insert(1);
   tree.print(std::cout); 
   tree.insert(5);
   tree.print(std::cout); 
   tree.insert(5);
   tree.print(std::cout); 
   tree.remove(1);
   tree.print(std::cout); 
   tree.remove(10);
   tree.print(std::cout); 
   tree.remove(5);
   tree.print(std::cout); 
   tree.remove(5);
   tree.print(std::cout); 

   srand(time(0));
   int N  = 100;
   int S = 0;
   clock_t clock0 = clock();
   for (int j = 0; j < 15; j++)
   {
     std::cout << "licze..." << std::flush;
     for (int i = 0; i < N; i++)
     {
         tree.insert( rand() + 60000*rand() );
     }
     clock_t clock1 = clock();
     std::cout.precision(4);
     std::cout << "\b\b\b\b\b\b\b\bsize: " << tree.size() 
         << ",\tb_height: " << tree.black_height() 
         << ",\theight: " << tree.height() 
         << ",\t(a= " << tree.height()/(log(tree.size())/log(2.0))  << ")\t";
     std::cout.precision(3);
     std::cout << (clock1 - clock0)/static_cast<double>(CLOCKS_PER_SEC) << "s"
               << std::endl;
     S += N;
     N = S;
   }
#ifndef NDEBUG
   std::cout << "(Debug)\n";
#else
   std::cout << "(Release)\n";
#endif
   return 0;
}